function [url,loaddodsbool,infotext,times,Pass_Times,depths,Pass_Depths,lats,lons,num_url] = gbrlctdc ...
         (getarchive, getranges, getmode)
%
%    This function will build gbrlctd/gbpar/gbchph/gbocctd/gbfvctd file names and 
%    return infotext and time/depth/lat/lon/url to the browser
%

% The preceding empty line is important
% $Log: gbrlctdc.m,v $
% Revision 1.3.8.2  2000/09/13 22:38:35  edavis
% Synch with new 3.2.x version from URI.
%
% Revision 1.5  2000/04/11 18:37:02  kwoklin
% Elimilate warning msg.  Add to handle full size constraint request.  klee
%
% Revision 1.3  1999/06/24 19:05:01  kwoklin
% Change file name of nbnerr.m. Fix some display bugs, define precision level
% of lat/lon/depth/time, and fix some more bugs in globec files.        klee
%
% Revision 1.1  1999/06/01 07:10:33  dbyrne
%
%
% Moved up from kleedata/
%
% Revision 1.3  1999/05/28 22:53:05  kwoklin
% Point to new server for all jgofs datasets. Update getjgsta on loaddods.
% Fix infotext for all gb geturl files. Fix transmissivity for some gb
% files. Modify some variable names on gb files.       klee
%

% $Id: gbrlctdc.m,v 1.3.8.2 2000/09/13 22:38:35 edavis Exp $
% fix depth representation to lat/lon basis            klee 05/28/99
% fix depth representation to min and max only         klee 05/05/99
% klee 04/01/99

% reading selected ranges

if exist(getarchive) == 2   
  eval(getarchive)
else
  dodsmsg('Metadata not found!')
  return
end

  % Initialize variables.
  More = 1;
  num_url = 0;  
  Pass_Times = []; times = [];
  Pass_Depths = []; depths = [];
  lats = []; lons = [];
  depthtemp = []; tmp = [];  outbs = []; outb = []; 
  url = []; infotext = []; text = []; Constraint = []; constraint = []; 
  % To prevent named file conflict, force variable names to be appeared as variables.
  year_s=[]; year_local=[]; year_utc=[]; month_s=[]; month_local=[]; month_utc=[];
  day_s=[]; day_local=[]; day_utc=[]; 
  lat_s=[]; lon_s=[]; lat=[]; lon=[]; pres=[]; press=[]; depth=[];

  DataRanges = [LonRange; LatRange; DepthRange; TimeRange];
  for i = 1:4
    if (getranges(i,1) <= DataRanges(i,1) & getranges(i,2) >= DataRanges(i,2))
      outb = [outb, 1];
   else
      outb = [outb, 0];
    end
  end
  outbs = outb(1:3); 
  yearname = deblank(DodsName1(1,:));
  monthname = deblank(DodsName1(2,:));
  dayname = deblank(DodsName1(3,:));

  %Now, for depth constraint
  Udepth = num2str(getranges(3,2),9);
  Ldepth = num2str(getranges(3,1),9);
  URLdepth = sprintf('%s', '&',DepthName,'>=',Ldepth,'&',DepthName,'<=',Udepth);

  %Now, for lat and lon constraint
  Ulat = num2str(getranges(2,2));
  Llat = num2str(getranges(2,1));
  URLlat = sprintf('%s','&',LatitudeName(1,:),'>=',Llat,'&',LatitudeName(1,:),'<=',Ulat);

  Llon = num2str(getranges(1,1));
  Rlon = num2str(getranges(1,2));
  % for [-180, 180]  
  URLlon = sprintf('%s','&',LongitudeName(1,:),'>=',Llon,'&',LongitudeName(1,:),'<=', Rlon);    

  Constraint = [URLdepth, URLlat, URLlon];

  % Get beginning and ending of time interval.
  BeginTime = max(TimeRange(1), getranges(4,1));
  LastTime = min(TimeRange(2), getranges(4,2));

  StartTime = BeginTime;

  LastYear = floor(LastTime);
  DaysInYear = 365;
  MonthFirstDay = [1 32 60 91 121 152 182 213 244 274 305 335 400];
  if isleap(LastYear)
    DaysInYear = 366;                % This is a leapyear.
    MonthFirstDay = [1 32 61 92 122 153 183 214 245 275 306 336 400];
  end
  LastDay = (LastTime - floor(LastTime)) * DaysInYear + 1;  
  LastDay = floor(LastDay);
  LastMonth = min(find(LastDay < MonthFirstDay)) - 1;
  LastMonthDay = LastDay - (MonthFirstDay(LastMonth)-1);

  depthtemp = []; lattemp = []; lontemp = [];
  returned_var = [];
  returned_var = sprintf('%s', yearname, ',', monthname, ',', dayname, ',', ...
                   LatitudeName(1,:), ',', LongitudeName(1,:), ',', DepthName);
  while More == 1
    StartYear = floor(StartTime);
    DaysInYear = 365;
    MonthFirstDay = [1 32 60 91 121 152 182 213 244 274 305 335 400];
    MonthDay = [31 28 31 30 31 30 31 31 30 31 30 31];
    if isleap(StartYear)
      DaysInYear = 366;                % This is a leapyear.
      MonthFirstDay = [1 32 61 92 122 153 183 214 245 275 306 336 400];
      MonthDay = [31 29 31 30 31 30 31 31 30 31 30 31];
    end
    StartDay = (StartTime - floor(StartTime)) * DaysInYear + 1;
    StartDay = floor(StartDay);
    StartMonth = max(find(StartDay >= MonthFirstDay));
    StartMonthDay = StartDay - (MonthFirstDay(StartMonth)-1);

    EndTime = StartYear + 1;
    EndYear = floor(EndTime);
    if EndTime >= LastTime   %all in the same year
      More = 0;
      EndTime = LastTime; EndMonth = LastMonth; EndMonthDay = LastMonthDay;
    else
      EndMonth = 12; EndMonthDay = 31; EndHour = 24; EndMin = 60;
      StartTime = EndTime;
    end

    manymonths = EndMonth - StartMonth + 1;
    if manymonths > 1
       months = StartMonth:EndMonth; 
       startmondays = [StartMonthDay; ones(size(months,2)-1,1)];
       lastmondays = [reshape(MonthDay(StartMonth:EndMonth-1),EndMonth-StartMonth,1); EndMonthDay];
    else  
       months = StartMonth; startmondays = StartMonthDay; lastmondays = EndMonthDay;
    end

    bool = 0;
    if all(outb == 1),  manymonths = 1;  end
    % if choosen acrose a year and the other three dims are covered all
    if manymonths == 12 & all(outbs == 1),  manymonths = 1;  bool = 1;  end

    for i = 1:manymonths
      if all(outb == 1)
        url = [Server, '?', returned_var];
        loaddods('-F',url);
        More = 0;
      else
        if bool
          % so far only the gbrlctd data are across years
          if strcmp(getarchive, 'gbrlctd')
            constraint = ['&',yearname,'=',num2str(StartYear)];
            url = [Server, '?', returned_var, constraint];
          else
            url = [Server, '?', returned_var];
          end
          loaddods('-F',url);
        else
          ce = ['&',yearname,'=',num2str(StartYear),'&',monthname,'=',num2str(months(i))];
          ce = [ce, '&',dayname,'>=',num2str(startmondays(i,1))];
          ce = [ce, '&',dayname,'<=',num2str(lastmondays(i,1))];
          constraint = [Constraint, ce];
          url = [Server, '?', returned_var, constraint];
          loaddods('-F',url);
        end
      end

      depthtemp = depths; lattemp = lats; lontemp = lons;
      dayp = [];  monthp = [];
      dayp = eval(dayname);  monthp = eval(monthname);
      if ~isempty(dayp) & dayp(1) > 1e-10
        %num_url = num_url + 1;
        if all(outb == 1) | bool
          monthp = MonthFirstDay(monthp);
        else
          monthp = MonthFirstDay(months(i));
        end
        daytemp = ((monthp'-1) + dayp - 1) / DaysInYear;
        timetemp = StartYear + daytemp;
        tmp = find(timetemp >= getranges(4,1) & timetemp <= getranges(4,2));
        if isempty(tmp)
          depths = depthtemp; lats = lattemp; lons = lontemp; 
        else
          num_url = num_url + 1;
          if all(outb == 1) | bool
            times = [times; timetemp(tmp)];
            Pass_Times = [Pass_Times; StartYear,13,0,0,str2num(Ldepth),...
                          str2num(Udepth),str2num(Llat),str2num(Ulat),str2num(Llon),str2num(Rlon)];
          else
            tmpstartmondays = round(min(daytemp(tmp)) * DaysInYear) - (monthp - 1) + 1;
            tmplastmondays = round(max(daytemp(tmp)) * DaysInYear) - (monthp - 1) + 1;
            times = [times; timetemp(tmp)];
            Pass_Times = [Pass_Times; StartYear,months(i),tmpstartmondays,tmplastmondays,str2num(Ldepth),...
                          str2num(Udepth),str2num(Llat),str2num(Ulat),str2num(Llon),str2num(Rlon)];
          end
          depths = [depths; eval(DepthName)];
          %depthtemp = [depthtemp; eval(DepthName)];
          lats = [lats; eval(LatitudeName(1,:))];
          lons = [lons; eval(LongitudeName(1,:))];
        end  %end of if isempty(tmp)
      end  %end of if dayp(1) 
    end  %end of for loop  
  end  %end of while loop
  %depths = [depths; max(depthtemp); min(depthtemp)];
  loaddodsbool = 0;

return
  

  
